/*
 * Copyright 2017-2020, Schlumberger
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.opengroup.osdu.notification.util;

import com.sun.jersey.api.client.ClientResponse;

import java.util.Map;

public abstract class RestDescriptor {

    public RestDescriptor() {
    }

    private String arg = "";

    public String arg() {
        return arg;
    }

    public abstract String getPath();

    public abstract String getHttpMethod();

    public abstract String getValidBody();

    public abstract Map<String, String> getOsduTenantHeaders();

    public abstract Map<String, String> getCustomerTenantHeaders();

    public String getQuery() {
        return "";
    }

    public ClientResponse runHttp(String arg, String token) throws Exception {
        this.arg = arg;
        return TestUtils.send(getPath(), getHttpMethod(), token, getValidBody(), getQuery(), getOsduTenantHeaders(), true);
    }

    public ClientResponse run(String arg, String token) throws Exception {
        this.arg = arg;
        return TestUtils.send(getPath(), getHttpMethod(), token, getValidBody(), getQuery(), getOsduTenantHeaders(), false);
    }

    public ClientResponse runOnCustomerTenant(String arg, String token) throws Exception {
        this.arg = arg;
        return TestUtils.send(getPath(), getHttpMethod(), token, getValidBody(), getQuery(), getCustomerTenantHeaders(), false);
    }

    public ClientResponse runOptions(String arg, String token) throws Exception {
        this.arg = arg;
        return TestUtils.send(getPath(), "OPTIONS", token, "", "", getOsduTenantHeaders(), false);
    }

    public ClientResponse run(String url, String arg, String token) throws Exception {
        this.arg = arg;
        return TestUtils.send(url, getPath(), getHttpMethod(), token, getValidBody(), getQuery(), getOsduTenantHeaders(), false);
    }
}